// unrrbpe.cpp, v1.01 2009/11/24
// coded by asmodean

// contact: 
//   web:   http://asmodean.reverse.net
//   email: asmodean [at] hush.com
//   irc:   asmodean on efnet (irc.efnet.net)

// This tool uncompresses BPE data used in Rumble Roses (PS2).

#include "as-util.h"
#include "as-bpe.h"

struct BPEHDR {
  unsigned char signature[4]; // "BPE "
  unsigned long unknown1;
  unsigned long length;
  unsigned long original_length;
};

int main(int argc, char** argv) {
  if (argc != 3) {
    fprintf(stderr, "unrrbpe v1.01 by asmodean\n\n");
    fprintf(stderr, "usage: %s <input> <output>\n", argv[0]);
    return -1;
  }

  string in_filename(argv[1]);
  string out_filename(argv[2]);

  int fd = as::open_or_die(in_filename, O_RDONLY | O_BINARY);

  BPEHDR hdr;
  read(fd, &hdr, sizeof(hdr));

  if (memcmp(hdr.signature, "BPE ", 4)) {
    fprintf(stderr, "%s: seems not BPE compressed data.\n", in_filename.c_str());
    return 0;
  }
  
  unsigned long  len  = hdr.length;
  unsigned char* buff = new unsigned char[len];
  read(fd, buff, len);
  close(fd);

  unsigned long  out_len  = hdr.original_length;
  unsigned char* out_buff = new unsigned char[out_len];
  as::unbpe(buff, len, out_buff, out_len);

  as::write_file(out_filename, out_buff, out_len);

  delete [] out_buff;
  delete [] buff;

  return 0;
}
